<!DOCTYPE html>
<!--
    (c) Copyright 2020 CERN for the benefit of the LHCb Collaboration

    This software is distributed under the terms of the GNU General Public
    Licence version 3 (GPL Version 3), copied verbatim in the file "COPYING".

    In applying this licence, CERN does not waive the privileges and immunities
    granted to it by virtue of its status as an Intergovernmental Organization
    or submit itself to any jurisdiction.
-->
<html>
<head>
  <meta charset="utf-8"/>

  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/themes/prism.css" rel="stylesheet" />
  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/themes/prism-okaidia.css" rel="stylesheet" />
  {#- Plugins #}
  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/line-numbers/prism-line-numbers.css" rel="stylesheet" />
  <link href="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/toolbar/prism-toolbar.css" rel="stylesheet" />

  <link href="/static/analysis-productions.css" rel="stylesheet" />
  <script src="/static/analysis-productions.js"></script>

{%- if test.output_files %}
  <script type="text/javascript" src="https://root.cern/js/6.1.1/scripts/JSRootCore.js?2d&gui">
{%- endif %}

  </script>
  <script type="text/javascript">
    document.addEventListener('DOMContentLoaded', function(event) {
      // Explain a job log on demand
      document.getElementById('toggle-job-log-explain').addEventListener('click', function() {
        var btn = document.getElementById('toggle-job-log-explain');
        btn.textContent = 'Loading...';

        fetch('explain-log/')
          .then(r => r.json().then(data => [r.ok, data]))
          .then(([ok, data]) => {
            if (!ok)
              throw new Error(data["message"]);
            var el = document.createElement('div');
            el.id = 'job-log-explain';
            lbap_fill_log_explanation(el, data.errors, 'Fatal errors:');
            lbap_fill_log_explanation(el, data.suggestions, 'Suggestions:');
            lbap_fill_log_explanation(el, data.explanations, 'Other explanations:');
            btn.parentElement.insertAdjacentElement('afterend', el);
            btn.style.display = 'none';
          }).catch((error) => {
            console.error('Error:', error);
            alert('Failed to get log explanation: ' + error);
            btn.textContent = 'ERROR!';
          });
      }, { once: true });
    });

{%- if test.output_files %}
    document.addEventListener('DOMContentLoaded', function(event) {
      // Set up JSROOT for browsing output files
      let display_root_button = document.querySelector('.button-display-jsroot');
      let jsroot_gui = document.querySelector('.jsroot-gui');
      let to_load = true;
      let root_button_click_callback = () => {
        if (! document.getElementById('simpleGUI')) {
          alert("No output file found");
        } else if (to_load) {
          JSROOT.BuildSimpleGUI();
          to_load = false;
        }
        jsroot_gui.classList.toggle('jsroot-gui');
      }
      dislay_root_button.addEventListener('click', root_button_click_callback, false);
    });
{%- endif %}
  </script>
</head>
<body class="line-numbers" data-toolbar-order="log-filters,copy-to-clipboard,select-code,download-file">

<h2>Analysis production job for <a href="/{{ test.pipeline.id }}/" class="mono-text">{{ test.production.name }}</a></h2>

<h1 class="mono-text">{{ test.job.name }}</h1>

<table>
  <tr>
    <th>Status</th>
    <th>Commit</th>
    <th>Requested</th>
    <th>Processed</th>
    <th>Runtime</th>
    <th>Kept</th>
  </tr>
  <tr class="job-status-{{ test.status.name|lower }}">
    <td><span>{{ test.status.name|title }}</span></td>
    <td><a href="{{ test.pipeline.job.job_url }}">{{ test.pipeline.job.commit_sha[:8] }}</a></td>
    <td>{{ test.events_requested }} events</td>
    <td>{{ test.events_processed }} events</td>
    <td>{{ in_hours(test.run_time, test.cpu_norm) }}</td>
    <td class="job-data-kept-{{ test.job.keep_output|lower }}">{{ test.job.keep_output }}</td>
  </tr>
</table>

<h3>Input</h3>

<table id="input-data-table">
  <tr>
    <th>Name</th>
    <th>Size</th>
    <th>Total {%- if test.job.parent %} (estimated){% endif %}</th>
  </tr>
{%- for input_file in test.input_files %}
  <tr>
{%- if test.job.parent %}
    <td><a href="/dynamic/{{ test.pipeline.id }}/{{ test.production.name }}/{{ test.job.parent.name }}/{{ test.job.parent.tests[-1].attempt if test.job.parent.tests else 0 }}/{{ input_file.path }}" class="mono-text">{{ input_file.path }}</a></td>
{%- else %}
    <td class="mono-text">{{ input_file.path }}</td>
{%- endif %}
    <td>{{ in_mb(input_file.size) }}</td>
    <td>{{ in_tb(input_file.dataset_size) }}</td>
  </tr>
{%- endfor %}
</table>

<h3>Output</h3>

<table id="output-data-table">
  <tr>
    <th>Name</th>
    <th>Size</th>
    <th>Total (estimated)</th>
  </tr>
{%- for output_file in test.output_files %}
  <tr>
    <td><a href="/dynamic/{{ test.pipeline.id }}/{{ test.production.name }}/{{ test.job.name }}/{{ test.attempt }}/{{ output_file.path }}" class="mono-text" download>{{ output_file.path }}</a></td>
    <td>{{ in_mb(output_file.size) }}</td>
    <td>{{ in_gb(output_file.dataset_size) }}</td>
  </tr>
{%- endfor %}
</table>

{%- if test.output_files %}
<h3 class="button-display-jsroot">Browse output file<span id="toggle-jsroot" class="display-button">Show</span></h3>
<div id="jsroot" class="jsroot-gui">
  <div id="simpleGUI"
        style="width:700px;height:400px;position:relative"
        path="/dynamic/{{ test.pipeline.id }}/{{ test.production.name }}/{{ test.job.name }}/{{ test.attempt }}/"
        files="{% for output_file in test.output_files %}{{output_file.path}}+;{% endfor %}"
        file="/dynamic/{{ test.pipeline.id }}/{{ test.production.name }}/{{ test.job.name }}/{{ test.attempt }}/{{test.output_files[0].path}}+"
        noselect
        ></div>
</div>
{%- endif %}

{% if test.finished -%}
<h3>Reproduce on lxplus:</h3>
<div id="reproduce-locally">
  <pre class="language-bash">
    <code>lb-ap reproduce {{ test.pipeline.id }} "{{ test.production.name }}" "{{ test.job.name }}" {{ test.attempt }}</code>
  </pre>
</pre>
</div>
{% endif -%}

<h3>Explain job log<span id="toggle-job-log-explain">Show</span></h3>

<h3>Job log<span id="toggle-job-log" class="display-button">Show</span></h3>
<a class="view-text-file-fallback" href="{{ log_fn }}">{{ log_fn }}</a>
<div id="job-log">
  <pre class="language-gaudirunlog"
       data-src="{{ log_fn }}"
       data-download-link data-download-link-label="Download"></pre>
</div>

<h3>DIRAC log<span id="toggle-dirac-log" class="display-button">Show</span></h3>
<a class="view-text-file-fallback" href="{{ dirac_log_fn }}">{{ dirac_log_fn }}</a>
<div id="dirac-log">
  <pre class="language-diracprodlog"
       data-src="{{ dirac_log_fn }}"
       data-download-link data-download-link-label="Download"></pre>
</div>

<footer>
  <p>
    If the logs show "Error 404 while fetching file: NOT FOUND" it is sign the test job has not started yet.
  </p>
  <p>For support see the <a href="https://mattermost.web.cern.ch/lhcb/channels/dpa-wp2-analysis-productions">DPA WP2 Analysis Productions</a> channel on mattermost.</p>
  <p>{{ version_string }}</p>
</footer>

<script src="https://cdnjs.cloudflare.com/ajax/libs/showdown/1.9.1/showdown.min.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/prism.js"></script>
{# Languages -#}
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/components/prism-bash.js"></script>
{# Plugins -#}
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/line-numbers/prism-line-numbers.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/toolbar/prism-toolbar.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/clipboard.js/2.0.4/clipboard.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/copy-to-clipboard/prism-copy-to-clipboard.js"></script>
<script src="https://cdnjs.cloudflare.com/ajax/libs/prism/1.16.0/plugins/normalize-whitespace/prism-normalize-whitespace.js"></script>
{# Customisations -#}
<script src="/static/prism-gaudirunlog.js"></script>
<script src="/static/prism-toolbar.js"></script>
</body>
</html>
